#!/usr/bin/python3

import os, requests, json, time

ramdir = '/var/www/html/openWB/ramdisk/'
moddir = '/var/www/html/openWB/modules/soc_eq/'

client_id     = os.environ.get('soc_eq_client_id', 'id')
client_secret = os.environ.get('soc_eq_client_secret', 'ecret')
VIN           = os.environ.get('soc_eq_vin', 'VIN')
soc_file      = os.environ.get('soc_file', ramdir + 'soc')
ChargePoint   = os.environ.get('CHARGEPOINT', '1')

tok_url   = "https://id.mercedes-benz.com/as/token.oauth2"
soc_url   = "https://api.mercedes-benz.com/vehicledata/v2/vehicles/"+VIN+"/resources/soc"
range_url = "https://api.mercedes-benz.com/vehicledata/v2/vehicles/"+VIN+"/resources/rangeelectric"

fd = open(moddir + 'expires_lp' + str(ChargePoint),'r')
expires_in = fd.read().rstrip()
fd.close()

if int(expires_in) < int(time.time()):
  fd = open(moddir + 'ref_tok_lp' + str(ChargePoint),'r')
  refresh_token = fd.read().rstrip()
  fd.close()

  data = {'grant_type': 'refresh_token', 'refresh_token': refresh_token }
  ref = requests.post(tok_url, data=data, verify=True, allow_redirects=False, auth=(client_id, client_secret))

  try:
    fd = open(ramdir + 'soc_eq_lastresp','w')
    fd.write(str(ref.status_code))
    fd.close()
  except:
    fd.close()

  if ref.status_code == 200:

    tok = json.loads(ref.text)

    access_token = tok['access_token']
    refresh_token = tok['refresh_token']
    expires_in = tok['expires_in'] - 60 + int(time.time())

    fd = open(moddir + 'acc_tok_lp' + str(ChargePoint),'w')
    fd.write(str(access_token))
    fd.close()

    fd = open(moddir + 'ref_tok_lp' + str(ChargePoint),'w')
    fd.write(str(refresh_token))
    fd.close()

    fd = open(moddir + 'expires_lp' + str(ChargePoint),'w')
    fd.write(str(expires_in))
    fd.close()
  else:
    exit(1)

fd = open(moddir + 'acc_tok_lp' + str(ChargePoint),'r')
access_token = fd.read().rstrip()
fd.close()

header = {'authorization': 'Bearer ' + access_token}
req_soc = requests.get(soc_url, headers=header, verify=True)

try:
  fd = open(ramdir + 'soc_eq_lastresp','w')
  fd.write(str(req_soc.status_code))
  fd.close()
except:
  fd.close()

if req_soc.status_code == 200:
  res = json.loads(req_soc.text)
  soc = res['soc']['value']
  fd = open(soc_file,'w')
  fd.write(str(soc))
  fd.close()

exit(0)
